import QtQuick 2.2
import Ubuntu.Components 1.1
import Ubuntu.Components.Popups 1.0
import Ubuntu.Components.ListItems 1.0 as ListItem

Page {
    id: pageDictCenter
    title: i18n.tr("Dictionaries")
    state: "default"
    states: [
        PageHeadState {
            name: "default"
            head: pageDictCenter.head
            actions: Action {
                iconName: "attachment"
                onTriggered: {
                    // TODO push import dict page
                    mainStack.push(Qt.resolvedUrl("./ContentHubPicker.qml"))
                }
            }
        }
    ]

    property var dictInfo

    Component.onCompleted: {
        dictInfo = dictCenter.getAllDictInfo()
        for (var i=0; i<dictInfo.length; i++) {
            modelDict.append(dictInfo[i])
        }

//        print("dict info: ", dictInfo.length)
    }

    flickable: null

    Flickable {
        id: scrollArea
        boundsBehavior: (contentHeight > height) ? Flickable.DragAndOvershootBounds : Flickable.StopAtBounds
        anchors.fill: parent
        contentWidth: width
        contentHeight: columnInnerArea.height + units.gu(3)
        clip: true

        Column {
            id: columnInnerArea

//            spacing: units.gu(1)
            anchors {
                top: parent.top;
                //                topMargin: units.gu(1)
//                margins: units.gu(1)
                left: parent.left; right: parent.right
                //                leftMargin: units.gu(1); rightMargin: units.gu(1)
            }
            height: childrenRect.height

            Repeater {
                model: modelDict

                ListItem.Standard {
                    text: dictname
                }
            }

        } //columnInnerArea
    }

    ListModel { id: modelDict }

}
