import QtQuick 2.2
import Ubuntu.Components 1.1
import Ubuntu.Components.ListItems 1.0 as ListItem
import Ubuntu.Components.Popups 1.0
import "../components"
import "../dict"

Page {
    id: pageSearch
    title: i18n.tr("AesyDict")
    state: "search"
    states: [
        PageHeadState {
            name: "default"
            head: pageSearch.head
            actions: [
                Action {
                    iconName: "search"
                    onTriggered: pageSearch.state = "search"
                }
                ,
                Action {
                    iconName: "attachment"
                    onTriggered: {
                        mainStack.push(Qt.resolvedUrl("../dict/PageDictCenter.qml"))
                    }
                }
            ]
        },
        PageHeadState {
            id: headerState
            name: "search"
            head: pageSearch.head
            actions: [
                Action {
                    id: acSearchStart
                    iconName: "search"
                    onTriggered: {
                        // TODO  start search session
                    }
                }
            ]
            backAction: Action {
                id: acleaveSearch
                text: i18n.tr("back")
                iconName: "back"
                onTriggered: pageSearch.state = "default"
            }
            contents: TextField {
                id: tfSearchWord
                anchors {
                    right: pageSearch.state == "search" ? parent.right : undefined
                    rightMargin: units.gu(1)
                }
                visible: pageSearch.state == "search"
                inputMethodHints: Qt.ImhNoPredictiveText | Qt.ImhNoAutoUppercase
                placeholderText: i18n.tr("Please input a word")

                onTextChanged: { timerSearch.stop(); timerSearch.start() }
            }
        }
    ]

    flickable: null

    Timer {
        id: timerSearch; interval: 700; running: false; repeat: false; triggeredOnStart: false
        onTriggered: {
            if (tfSearchWord.text != "") {
                dictCenter.searchWords(tfSearchWord.text)
            }
        }
    }

    ////////////////////////////////////
    //   property & function & connection for adding search result to this page
    ////////////////////////////////////
    property var dictArray: []

    function addResultToList(wList, dName) {
        print("dictArray.length: ", dictArray.length)
        var isExist = false
        for (var i=0; i<dictArray.length; i++) {
            if(dictArray[i].dictName === dName) {
                dictArray[i].initial(wList, dName)
                isExist = true
                break
            }
        }
        if (!isExist) {
            var component = Qt.createComponent("../components/ResultWordList.qml");
            var obj = component.createObject(columnInnerArea);
            obj.initial(wList, dName)
            dictArray.push(obj)
        }
    }

    Connections {
        target: dictCenter
        onSearchWordsResult: {
            addResultToList(wordList, dictName)
        }

//        onGetWordDetailResult: {
//            console.log("qml, word detail: ", JSON.stringify(wordDetail))
//        }
    }

    Flickable {
        id: scrollArea
        boundsBehavior: (contentHeight > height) ? Flickable.DragAndOvershootBounds : Flickable.StopAtBounds
        anchors.fill: parent
        contentWidth: width
        contentHeight: columnInnerArea.height + units.gu(3)
        clip: true

        Column {
            id: columnInnerArea

//            spacing: units.gu(1)
            anchors {
                top: parent.top;
                //                topMargin: units.gu(1)
                margins: units.gu(1)
                left: parent.left; right: parent.right
                //                leftMargin: units.gu(1); rightMargin: units.gu(1)
            }
            height: childrenRect.height

//            TextArea {
//                id: ta
//            }

//            ListItem.Caption {
//                text: "English - Chinese Dictionary"
//            }
//            ListItem.ThinDivider {}

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Caption {
//                text: "English - Chinese Dictionary"
//            }
//            ListItem.ThinDivider {}

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Caption {
//                text: "English - Chinese Dictionary"
//            }
//            ListItem.ThinDivider {}

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Standard {
//                text: "aaa"
//            }

//            ListItem.Standard {
//                text: "aaa"
//            }

        } // columnInnerArea
    }
}

